

import os

tests= [('StorageManager','test_global_cache'),
        ('StorageManager','test_storage_manager'),
        ('.','test_persistent_object'),
        ('.','test_collection'),
        ('MetaData','test_module'),
        ('Collections','test_collection_base'),
        ('Collections','test_all_collections'),
        ('StorageManager','test_create_and_destroy'), #At this point the basic infastructure has been tested
        ('MetaData','test_all_metadata'),
        ('.','test_interface_creation'),
        ('.','basic_test1'),
        ('.','relationship_test'),
        ('.','constants_test'),
        ('.','enumeration_test'),
        ('.','extent_test'),
        ('.','binding_test'),
        ('.','types_test'),
        ('.','blob_test'),
        ('.','collections_test'),
        ('.','collections_test2'),
        ('.','object_attribute_test'),
        ('.','copy_test'),
]

from Ft.Ods.StorageManager import Adapters
if Adapters.GetDriver() != Adapters.GetDriver('Dbm'):
    tests = tests + [('.','circular_reference_test'),
                     ('.','memory_test'),
                     ('.','leave_join_test'),
                     ('.','mthread_test'),
                     ]



from Ft.Ods import Database
import time
from Ft.Ods.StorageManager import GlobalCache
from Ft.Ods.StorageManager.Adapters import ClassCache

def test(tester,name=None):

    global tests
    db = Database.Database()
    failed = []
    if name:
        tests = [name]

    test_total = 0
    for dir,test in tests:
        cwd = os.getcwd()
        os.chdir(dir)
        GlobalCache.GlobalCache().purgeAll()
        ClassCache.ClassCache().purgeAll()
        if 1:
        #try:
            start = time.time()
            mod = __import__(test, {}, {}, '*')
            mod.test(tester)
            total = time.time() - start
            print "%s Completed in %f" % (test, total)
            # There has to be at least 1 sec between tests
            # Python byte-compiles based on 1-second itervals
            if total < 2:
                time.sleep(2 - total)
            test_total = test_total + total
        #except:
        #    failed.append(test)
        os.chdir(cwd)

    print "*"*40
    print "Total test time : %f" % test_total

    if failed:
        sys.stderr.write("The following tests failed\n")        
    for f in failed:
        sys.stderr.write("\t%s\n"%f)        
        

if __name__ == '__main__':

    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1, 1)

    import sys
    if len(sys.argv) == 2:
        test(tester,sys.argv[1])
    else:

        test(tester)
