#Stefan Seefeld <seefeld@sympatico.ca> has trouble with the docbook stylesheets

import os, sys
sys.path.append('../')
import test_harness

source_1 = """\
<book>
  <chapter><title>Chapter</title>
  <sect1><title>Sect1</title>
  <sect2><title>Sect2</title>
  </sect2>
  </sect1>
  </chapter>
</book>
"""

saxon_6_0_2_expected = """\
<html><head>
      <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
   <title></title><meta name="generator" content="DocBook XSL Stylesheets V1.29"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" id="c35b1"><div class="titlepage"><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt>1. <a href="#c35b1b1">Chapter</a></dt><dd><dl><dt> <a href="#c35b1b1b2">Sect1</a></dt><dd><dl><dt> <a href="#c35b1b1b2b2">Sect2</a></dt></dl></dd></dl></dd></dl></div><div id="c35b1b1" class="chapter"><div class="titlepage"><div><h2 class="title"><a name="c35b1b1"></a>Chapter 1. Chapter</h2></div></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt> <a href="#c35b1b1b2">Sect1</a></dt><dd><dl><dt> <a href="#c35b1b1b2b2">Sect2</a></dt></dl></dd></dl></div><div class="sect1"><a name="c35b1b1b2"></a><div class="titlepage"><div><h2 class="title" style="clear: all"><a name="c35b1b1b2"></a><span class="title">Sect1</span></h2></div></div><div class="sect2"><a name="c35b1b1b2b2"></a><div class="titlepage"><div><h3 class="title"><a name="c35b1b1b2b2"></a><span class="title">Sect2</span></h3></div></div></div></div></div></div></body></html>"""


#Ouch!  Can't compare because of the generate-id() values
#Prolly come up with a smart compare that can ignore portions if they
#match a pattern

expected_1 = """\
<html><head>
      <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
   <title></title><meta name="generator" content="DocBook XSL Stylesheets V1.29"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" id="c35b1"><div class="titlepage"><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt>1. <a href="#c35b1b1">Chapter</a></dt><dd><dl><dt> <a href="#c35b1b1b2">Sect1</a></dt><dd><dl><dt> <a href="#c35b1b1b2b2">Sect2</a></dt></dl></dd></dl></dd></dl></div><div id="c35b1b1" class="chapter"><div class="titlepage"><div><h2 class="title"><a name="c35b1b1"></a>Chapter 1. Chapter</h2></div></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt> <a href="#c35b1b1b2">Sect1</a></dt><dd><dl><dt> <a href="#c35b1b1b2b2">Sect2</a></dt></dl></dd></dl></div><div class="sect1"><a name="c35b1b1b2"></a><div class="titlepage"><div><h2 class="title" style="clear: all"><a name="c35b1b1b2"></a><span class="title">Sect1</span></h2></div></div><div class="sect2"><a name="c35b1b1b2b2"></a><div class="titlepage"><div><h3 class="title"><a name="c35b1b1b2b2"></a><span class="title">Sect2</span></h3></div></div></div></div></div></div></body></html>"""


def Test(tester):
    tester.startGroup("Borrowed: ss_20010301")
    if not os.access('docbook', os.F_OK):
        tester.startTest('Checking for stylesheet')
        tester.warning("You need Norm Walsh's Docbook stylesheet package to run this test")
        tester.warning("You can either ignore this, or you can install dbxXXX.zip")
        tester.warning("inside the 4XSLT/test_suite/borrowed directory")
        tester.warning("where XXX is the version number, which would be at least 129.")
        tester.testDone()
        tester.groupDone()
        return 1

    source = test_harness.FileInfo(string=source_1)
    sty = test_harness.FileInfo(uri='docbook/html/docbook.xsl')
    xtest = test_harness.XsltTester(source,
                                    [sty],
                                    expected_1,
                                    compareFunc = cmp,
                                    )

    res = xtest.test(tester)
    tester.groupDone()
    return res

if __name__=='__main__':
    from Ft.Lib import TestSuite
    tester = TestSuite.TestSuite(1,1)
    Test(tester)

