from Ft.Lib import TestSuite
from Ft.Lib import XUpdate
from Ft.Lib import pDomlette
import xml.dom.ext
import cStringIO

#From the spec

src_1 = """\
<?xml version="1.0"?>
<addresses version="1.0">

  <address id="1">
    <fullname>Andreas Laux</fullname>
    <born day='1' month='12' year='1978'/>
    <town>Leipzig</town>
    <country>Germany</country>
  </address>

</addresses>
"""

xu_1 = """\
<?xml version="1.0"?>
<xupdate:modifications
  version="1.0"
  xmlns:xupdate="http://www.xmldb.org/xupdate"
>

  <xupdate:insert-after select="/addresses/address[1]" >

    <xupdate:element name="address">
      <xupdate:attribute name="id">2</xupdate:attribute>
      <fullname>Lars Martin</fullname>
      <born day='2' month='12' year='1974'/>
      <town>Leizig</town>
      <country>Germany</country>
    </xupdate:element>
  </xupdate:insert-after>

</xupdate:modifications>
"""

expected_1 = """<?xml version='1.0' encoding='UTF-8'?><addresses version='1.0'>

  <address id='1'>
    <fullname>Andreas Laux</fullname>
    <born day='1' month='12' year='1978'/>
    <town>Leipzig</town>
    <country>Germany</country>
  </address>

    <address id='2'>
      
      <fullname>Lars Martin</fullname>
      <born/>
      <town>Leizig</town>
      <country>Germany</country>
    </address>
  

</addresses>"""

#etc

reader = pDomlette.PyExpatReader()
xureader = XUpdate.Reader()

def Test(tester):
    processor = XUpdate.Processor()
    tester.startGroup("XUpdate")
    src = reader.fromString(src_1)
    xu = xureader.fromString(xu_1)

    processor.execute(src, xu)
    st = cStringIO.StringIO()
    
    xml.dom.ext.Print(src,stream=st)
    
    tester.startTest("XUpdate spec example 1")

    tester.testResults(expected_1, st.getvalue(),done=0,msg="XUpdate",diff=1)

    tester.testDone()
    tester.groupDone()


if __name__ == '__main__':
    tester = TestSuite.TestSuite(1, 1)
    Test(tester)

